package jp.takayuki.swt.util;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Widget;

/**
 * |bvAbvj[\Cxg̏dĂяo}܂B
 * <p>
 * SWT 3.6.2CocoavbgtH[ɂāA
 * |bvAbvj[MenuDetect2Ăяo肨
 * eCompositeɐݒ肵|bvAbvj[qCompositeł
 * \(|bvAbvj[2ĕ\)ɑΏ܂B
 * <p>
 * |bvAbvj[ݒ肵EBWFbgɑ΂Ďgp܂B
 * 
 * @author Takayuki Shoji
 */
public class CocoaMenuDetectSuppressor implements Listener {

	/**
	 * singleton instance
	 */
	private static CocoaMenuDetectSuppressor instance;

	/**
	 * pb`CXg[܂B
	 * @param widget POP_UPݒ肵EBWFbg
	 */
	public static void install(Widget widget) {
		if (SWT.getPlatform().equals("cocoa")) { //$NON-NLS-1$
			if (instance == null) {
				instance = new CocoaMenuDetectSuppressor();
			}
			widget.removeListener(SWT.MenuDetect, instance);
			widget.addListener(SWT.MenuDetect, instance);
		}
	}

	/**
	 * time previously invoked.
	 */
	private int time;

	/**
	 * private constructor.
	 */
	private CocoaMenuDetectSuppressor() {
		//
	}

	public void handleEvent(Event event) {
		if (event.time == time) {
			event.doit = false;
		} else {
			time = event.time;
		}
	}

}
