package petaclone;

import jp.takayuki.tools.Version;

import org.eclipse.swt.widgets.Shell;

import petaclone.swt.SWTMainWindow;
import petaclone.swt.SWTUpdateWindow;
import petaclone.swt.logic.AbstractSWTEventListener;

/**
 * XVt@C_E[hCxg
 * @author Takayuki Shoji
 */
public class ApplicationUpdateDownloaded extends AbstractSWTEventListener {

	/**
	 * eEBhE(CEBhEShell)
	 */
	private final Shell parent;

	/**
	 * CEBhE
	 */
	private final SWTMainWindow main;

	/** Cxgʒm */
	private final EventBroker broker;

	/**
	 * RXgN^
	 * @param parent eEBhE(CEBhEShell)
	 * @param main CEBhE
	 * @param broker Cxgʒm
	 */
	public ApplicationUpdateDownloaded(Shell parent, SWTMainWindow main,
			EventBroker broker) {
		this.parent = parent;
		this.main = main;
		this.broker = broker;

	}

	protected void handleEvent(String eventName, Object event) {
		Version ev = (Version) event;
		SWTUpdateWindow win = new SWTUpdateWindow(main, parent, broker,
				main.getAppPreferences(), ev);
		win.open();
	}

}
