package petaclone.ipmsg;

/**
 * 萔
 * @author Takayuki Shoji
 */
public class IPMSG {
	/** }XNrbg: R}h */
	static final long MASK_COMMAND = 0x000000ffL;
	/** }XNrbg: IvV */
	static final long MASK_OPTION = 0xffffff00L;

	/** R}h:  */
	static final long NOOPERATION = 0x00000000L;

	/** R}h: o^ */
	static final long BR_ENTRY = 0x00000001L;
	/** R}h: 폜 */
	static final long BR_EXIT = 0x00000002L;
	/** R}h: ԓ */
	static final long ANSENTRY = 0x00000003L;
	/** R}h: XVʒm(s݃[hAO) */
	static final long BR_ABSENCE = 0x00000004L;

	/** R}h: zXgXgo\ʒm */
	static final long OKGETLIST = 0x00000011L;
	/** R}h: zXgXgov */
	static final long GETLIST = 0x00000012L;
	/** R}h: zXgXgo */
	static final long ANSLIST = 0x00000013L;
	/** R}h: zXgXgo\o̒T(BR_ISGETLIST2) */
	static final long BR_ISGETLIST2 = 0x00000018L;

	/** R}h: ʏ탁bZ[W̑M */
	static final long SENDMSG = 0x00000020L;
	/** R}h: ʏ탁bZ[W̎Mʒm */
	static final long RECVMSG = 0x00000021L;

	/** R}h: ̊Jʒm */
	static final long READMSG = 0x00000030L;
	/** R}h: ̔jʒm */
	static final long DELMSG = 0x00000031L;
	/** R}h: ̊Jʒm̎Mʒm */
	static final long ANSREADMSG = 0x00000032L;

	/** }XNrbg: ʏ탁bZ[WƊJʒmAjʒm */
	static final long MASK_MESSAGE = SENDMSG | READMSG | DELMSG;

	/** R}h: IPMSGo[W擾 */
	static final long GETINFO = 0x00000040L;
	/** R}h: IPMSGo[W񉞓 */
	static final long SENDINFO = 0x00000041L;

	/** R}h: sݒʒm̑Mv */
	static final long GETABSENCEINFO = 0x00000050L;
	/** R}h: sݒʒm̑M */
	static final long SENDABSENCEINFO = 0x00000051L;

	/** (TCP)R}h: Ytt@Cv */
	static final long GETFILEDATA = 0x00000060L;
	/** (UDP)R}h: Ytt@Cj */
	static final long RELEASEFILES = 0x00000061L;
	/** (TCP)R}h: fBNg̗v */
	static final long GETDIRFILES = 0x00000062L;

	/** R}h: RSA J擾 */
	static final long GETPUBKEY = 0x00000072L;
	/** R}h: RSA J */
	static final long ANSPUBKEY = 0x00000073L;

	/** SR}hʃIvV: s݃[hioFnR}hŎgpj */
	static final long ABSENCEOPT = 0x00000100L;
	/** SR}hʃIvV: T[o[i\j */
	static final long SERVEROPT = 0x00000200L;
	/** SR}hʃIvV: oFñR}hʂɑԂ */
	static final long DIALUPOPT = 0x00010000L;
	/** SR}hʃIvV:
	 * t@CYtɑΉĂ,bZ[WɃt@CYtĂ */
	static final long FILEATTACHOPT = 0x00200000L;
	/** SR}hʃIvV:
	 * ÍɑΉĂ,bZ[WÍĂ */
	static final long ENCRYPTOPT = 0x00400000L;
	/** SR}hʃIvV:
	 * UTF-8gpbZ[W */
	static final long UTF8OPT = 0x00800000L;
	/** SR}hʃIvV:UTF-8gp\͂ */
	static final long CAPUTF8OPT = 0x01000000L;
	/** SR}hʃIvV:t@CYtÍɊ܂߂ */
	static final long ENCEXTMSGOPT = 0x04000000L;
	/** SR}hʃIvV:CC摜M\ */
	static final long CLIPBOARDOPT = 0x08000000L;

	/* option for send command */

	/** MpIvV: M`FbN(Mʒm̗v) */
	static final long SENDCHECKOPT = 0x00000100L;
	/** MpIvV: bZ[W */
	static final long SECRETOPT = 0x00000200L;
	/** MpIvV: ̃bZ[W̓u[hLXgłB */
	static final long BROADCASTOPT = 0x00000400L;
	/** MpIvV: ̃bZ[W̓}`LXgłB */
	static final long MULTICASTOPT = 0x00000800L;
	/** MpIvV: (sgp)
	 * @deprecated */
	static final long NOPOPUPOPT = 0x00001000L;
	/** MpIvV: ꂽbZ[W(Ɏ) */
	static final long AUTORETOPT = 0x00002000L;
	/** MpIvV: đtOiHOSTLIST 擾Ɏgpj */
	static final long RETRYOPT = 0x00004000L;
	/** MpIvV: pX[hKvȃbZ[W */
	static final long PASSWORDOPT = 0x00008000L;
	/** MpIvV: OɕۑȂłق */
	static final long NOLOGOPT = 0x00020000L;
	/** MpIvV: (\)
	 * @deprecated */
	static final long NEWMUTIOPT = 0x00040000L;
	/** MpIvV: BR_ENTRYĂȂꎞoʒm */
	static final long NOADDLISTOPT = 0x00080000L;
	/** MpIvV: JmF̓Bʒm */
	static final long READCHECKOPT = 0x00100000L;

	/** Í: RSA 512rbg */
	static final long RSA_512 = 0x00000001L;
	/** Í: RSA 1024rbg */
	static final long RSA_1024 = 0x00000002L;
	/** Í: RSA 2048rbg */
	static final long RSA_2048 = 0x00000004L;
	/** Í: RC2 40rbg */
	static final long RC2_40 = 0x00001000L;
	/** Í: RC2 128rbg
	 * @deprecated */
	static final long RC2_128 = 0x00004000L;
	/** Í: RC2 256rbg
	 * @deprecated */
	static final long RC2_256 = 0x00008000L;
	/** Í: Blowfish 128rbg */
	static final long BLOWFISH_128 = 0x00020000L;
	/** Í: Blowfish 256rbg
	 * @deprecated */
	static final long BLOWFISH_256 = 0x00040000L;
	/** Í: AES 128rbg
	 * @deprecated */
	static final long AES_128 = 0x00080000L;
	/** Í: AES 256rbg */
	static final long AES_256 = 0x00100000L;
	/** Í: ʌÍ IV  Packetԍ𗘗p */
	static final long PACKETNO_IV = 0x00800000L;
	/** Í: Í̋ʌȍ~̋Lq base64 𗘗p */
	static final long ENCODE_BASE64 = 0x01000000L;
	/** Í: MD5ɂ鏐
	 * @deprecated */
	static final long SIGN_MD5 = 0x10000000L;
	/** Í: SHA1dqt^ */
	static final long SIGN_SHA1 = 0x20000000L;

	/* file types for fileattach command */
	
	/** t@C^Cv: ʏ̃t@C */
	static final long FILE_REGULAR = 0x00000001L;
	/** t@C^Cv: fBNg */
	static final long FILE_DIR = 0x00000002L;

	/** t@C^Cv: 1̃fBNgɖ߂ */
	static final long FILE_RETPARENT = 0x00000003L;
	/** t@C^Cv: V{bNN */
	static final long FILE_SYMLINK = 0x00000004L;

	/* for UNIX */
	/** t@C^Cv: CDEV(for UNIX) */
	static final long FILE_CDEV = 0x00000005L;
	// for UNIX
	/** t@C^Cv: BDEV(for UNIX) */
	static final long FILE_BDEV = 0x00000006L;
	// for UNIX
	/** t@C^Cv: FIFO(for UNIX) */
	static final long FILE_FIFO = 0x00000007L;

	/* for Mac */
	/** t@C^Cv: \[XtH[N(for Mac) */
	static final long FILE_RESFORK = 0x00000010L;

	/*  */
	/** CC摜 */
	static final long FILE_CLIPBOARD = 0x00000020L;

	/* file attribute options for fileattach command */
	/** t@C: ǂݎp */
	static final long FILE_RONLYOPT = 0x00000100L;
	/** t@C: Bt@C */
	static final long FILE_HIDDENOPT = 0x00001000L;

	/** t@C: Bt@C(for Mac OS X) */
	static final long FILE_EXHIDDENOPT = 0x00002000L;
	/** t@C: A[JCu */
	static final long FILE_ARCHIVEOPT = 0x00004000L;
	/** t@C: VXet@C */
	static final long FILE_SYSTEMOPT = 0x00008000L;

	/* extend attribute types for fileattach command */
	/** gt@C: [U[ID */
	static final long FILE_UID = 0x00000001L;
	// uid by string
	/** gt@C: [U[ */
	static final long FILE_USERNAME = 0x00000002L;
	/** gt@C: O[vID */
	static final long FILE_GID = 0x00000003L;
	// gid by string
	/** gt@C: O[v */
	static final long FILE_GROUPNAME = 0x00000004L;
	/** gt@C: CC摜}ʒu */
	static final long FILE_CLIPBOARDPOS = 0x00000008L;
	// for UNIX
	/** gt@C: p[~bV */
	static final long FILE_PERM = 0x00000010L;
	// for UNIX devfile
	/** gt@C: W[ԍ */
	static final long FILE_MAJORNO = 0x00000011L;
	// for UNIX devfile
	/** gt@C: }Ci[ԍ */
	static final long FILE_MINORNO = 0x00000012L;
	// for UNIX
	/** gt@C: 쐬 */
	static final long FILE_CTIME = 0x00000013L;
	/** gt@C: ŏIύX */
	static final long FILE_MTIME = 0x00000014L;
	/** gt@C: ŏIANZX */
	static final long FILE_ATIME = 0x00000015L;
	/** gt@C: 쐬 */
	static final long FILE_CREATETIME = 0x00000016L;
	// for Mac
	/** gt@C: NG[^(for Mac) */
	static final long FILE_CREATOR = 0x00000020L;
	// for Mac
	/** gt@C: ^Cv(for Mac) */
	static final long FILE_FILETYPE = 0x00000021L;
	// for Mac
	/** gt@C: Finder(for Mac) */
	static final long FILE_FINDERINFO = 0x00000022L;

	/** gt@C:  */
	static final long FILE_ACL = 0x00000030L;
	/** gt@C: GCAXt@C */
	static final long FILE_ALIASFNAME = 0x00000040L;
	/** gt@C: Unicodet@C */
	static final long FILE_UNICODEFNAME = 0x00000041L;

	/** t@CXg̋؂ */
	static final String FILELIST_SEPARATOR = "\7"; //$NON-NLS-1$
	/** zXgXg̋؂ */
	static final String HOSTLIST_SEPARATOR = "\7"; //$NON-NLS-1$

	/** RSA */
	static final String CIPHER_RSA = "RSA/ECB/PKCS1Padding"; //$NON-NLS-1$

	/** Blowfish */
	static final String CIPHER_BLOWFISH = "Blowfish/CBC/PKCS5Padding"; //$NON-NLS-1$

	/** RC2 */
	static final String CIPHER_RC2 = "RC2/CBC/PKCS5Padding"; //$NON-NLS-1$

	/**  */
	static final String CIPHER_PLAIN = "plain"; //$NON-NLS-1$
}
