package petaclone.swt;

import java.io.IOException;
import java.io.InputStream;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;

/**
 * }XNꂽImage擾܂B
 * @author Takayuki Shoji
 *
 */
public class TransparentImage {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(TransparentImage.class);

	/**
	 * }XNꂽImage擾܂B
	 * @param device foCX
	 * @param fileName t@C
	 * @return ImageIuWFNg
	 */
	public static Image get(Device device, String fileName) {
		String path = "/icons/" + fileName; //$NON-NLS-1$
		InputStream is = TransparentImage.class.getResourceAsStream(path);
		if (is == null) {
			logger.warn("No resource found:" + path); //$NON-NLS-1$
			return null;
		}
		try {
			ImageData imageData = new ImageData(is);
			ImageData mask = imageData.getTransparencyMask();
			Image image = new Image(device, imageData, mask);
			return image;
		} finally {
			try {
				is.close();
			} catch (IOException e) {
				logger.error("Exception occurred while closing input stream.", //$NON-NLS-1$
						e);
			}
		}
	}
}
