package petaclone.swt.logic;

import org.eclipse.swt.widgets.Display;

import petaclone.EventListener;

/**
 * SWTUIɊւCxgsx[XNXłB
 * @author Takayuki Shoji
 */
public abstract class AbstractSWTEventListener implements EventListener {

	/**
	 * UIsp
	 */
	private Display display = Display.getDefault();

	/**
	 * Cxg
	 */
	final public void listen(String eventName, Object event) {
		if (display.isDisposed()) {
			return;
		}
		if (display.getThread() == Thread.currentThread()) {
			handleEvent(eventName, event);
		} else {
			display.asyncExec(new Action(eventName, event));
		}
	}

	/**
	 * TuNXŃCxg܂B
	 * @param eventName Cxg
	 * @param event CxgIuWFNg
	 */
	abstract protected void handleEvent(String eventName, Object event);

	/**
	 * Cxg
	 */
	private class Action implements Runnable {

		/**
		 * Cxg
		 */
		private String eventName;

		/**
		 * CxgIuWFNg
		 */
		private Object event;

		/**
		 * RXgN^
		 * @param eventName Cxg
		 * @param event CxgIuWFNg
		 */
		public Action(String eventName, Object event) {
			this.eventName = eventName;
			this.event = event;
		}

		/**
		 * Cxg܂B
		 */
		public void run() {
			handleEvent(eventName, event);
		}
	}

	/**
	 * RXgN^Ŏ󂯎DisplayԂ܂B
	 * @return Display
	 */
	protected Display getDisplay() {
		return this.display;
	}
}
