package petaclone.swt.logic;

import java.io.IOException;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.Os;
import jp.takayuki.tools.Tool;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import petaclone.swt.SWTMainWindow;

/**
 * ׂẴEBhEŏ܂B
 * @author Takayuki Shoji
 */
public class SWTMinimizeAllWindows extends AbstractSWTEventListener {

	/** log */
	private static final Logger logger = Logger
			.getLogger(SWTMinimizeAllWindows.class);

	/**
	 * CEBhE
	 */
	private SWTMainWindow main;

	/**
	 * RXgN^
	 * @param main CEBhE
	 */
	public SWTMinimizeAllWindows(SWTMainWindow main) {
		this.main = main;
	}

	/**
	 * Cxg
	 */
	protected void handleEvent(String eventName, Object event) {
		if (SWTUtils.isDialogShellOpened()) {
			return;
		}

		if (Os.isMacOSX()) {
			// Mac OS XłHide
			try {
				String[] command = new String[] { "osascript", "-e", //$NON-NLS-1$ //$NON-NLS-2$
						"tell application \"System Events\" to set visible of process \"Petaclone\" to false" }; //$NON-NLS-1$
				Process p = Runtime.getRuntime().exec(command);
				p.waitFor();
			} catch (IOException e) {
				logger.error("Exception occurred during hiding application.", //$NON-NLS-1$
						e);
			} catch (InterruptedException e) {
				logger.error("Exception occurred during hiding application.", //$NON-NLS-1$
						e);
			}
			return;
		}

		main.minimize();
		Shell[] shells = SWTUtils.getVisibleShells(null, false, false);
		if (shells == null) {
			return;
		}
		// ̃gbvxEBhE
		for (int i = 0; i < shells.length; i++) {
			if (Tool.hasFlag(shells[i].getStyle(), SWT.MIN)) {
				shells[i].setMinimized(true);
			}
		}
	}

}
