package petaclone;

/**
 * bZ[W̔r
 * @author Takayuki Shoji
 */
public class MessageComparator implements TableComparator {

	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 1L;

	/** OɃ\[gꂽԍ */
	private int column = -1;

	/** \[g */
	private int sortDirection = -1;

	/**
	 * @see petaclone.TableComparator#setSortOrder(int)
	 */
	public void setSortColumn(int column) {
		if (this.column == column) {
			// \[gς݂̏ꍇ͍~ɂ
			sortDirection *= -1;
		} else {
			// \[gĂȂꍇ͏
			sortDirection = 1;
		}
		this.column = column;
	}

	/**
	 * @return \[g
	 */
	public int getSortDirection() {
		return sortDirection;
	}

	/**
	 * @see java.util.Comparator#compare(Object, Object)
	 */
	public int compare(Object o1, Object o2) {
		Message msg1 = (Message) o1;
		Message msg2 = (Message) o2;
		return msg1.compareBy(this.column, msg2) * this.sortDirection;
	}

}
