package petaclone;

import java.io.File;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;

/**
 * bZW[̃T[oANCAg̃C^[tF[X
 * @author Takayuki Shoji
 */
public interface Messenger {

	/**
	 * VCX^X𐶐܂B
	 * @return ꂽCX^X
	 */
	Messenger newInstance();

	/**
	 * T[oJn܂B
	 * @param group T[oXbhɐݒ肷ׂXbhO[v
	 * @throws LaunchException NO
	 */
	void begin(ThreadGroup group) throws LaunchException;

	/**
	 * T[oɏIʒm܂B
	 */
	void quit();

	/**
	 * T[oĂ邩ǂԂ܂B
	 * u[hLXgñ\bhgO
	 * Xe[^XꗗƂȂǂɎg܂B
	 * @return Ătrue
	 */
	boolean getAlive();

	/**
	 * AppPreferencesݒ肵܂B
	 * @param pref AvP[Vݒ
	 */
	void setAppPreferences(AppPreferences pref);

	/**
	 * CX^X̐ݒݒ肵܂B
	 * @param conf Nݒ
	 */
	void setConfiguration(LaunchConfiguration conf);

	/**
	 * NID(CX^X̐ݒID)Ԃ܂B
	 * NĂȂꍇnullԂ܂B
	 * @return NID
	 */
	String getId();

	/**
	 * T[oXi[ǉ܂B
	 * @param listener ǉ郊Xi[
	 */
	void setServerListener(ServerListener listener);

	/**
	 * o^pPbg𑗐M܂B(N̂)
	 */
	void sendRegister();

	/**
	 * ČpPbg𑗐M܂B
	 * @param addOnly ǉ̂ݍsAFς݂̃o[폜ȂꍇtrueB
	 */
	void sendFind(boolean addOnly);

	/**
	 * OύXʒmpPbg𑗐M܂B
	 */
	void sendRename();

	/**
	 * sݏԕύXʒmpPbg𑗐M܂B
	 * @param isAbsence sݏ
	 */
	void sendAbsenceMode(boolean isAbsence);

	/**
	 * bZ[W𑗐M܂B
	 * MʂServerListenerŒʒm܂B
	 * 񓯊ŎB
	 * @param message M郁bZ[W
	 * @param destinations bZW[Ƃ̂ĐB
	 * @param listener ʂ̒ʒm
	 */
	void sendMessage(Message message, UniqueMember[] destinations,
			SendingResultListener listener);

	/**
	 * Jʒm𑗐M܂B
	 * @param message ̃bZ[Wɑ΂Jʒm𑗂܂B
	 **/
	void sendOpenNotice(Message message);

	/**
	 * gpĂvgȐԂ܂B
	 * @return vgR
	 */
	Protocol getProtocol();

	/**
	 * ݒ_CAÕbZW[^uɃRg[zu܂B<br>
	 * creator삷ׂvpeB[mĂ̂Messenger
	 * LaunchConfiguration͎QƂȂƁB
	 * @param creator NG[^
	 */
	void createConfigControl(ControlCreator creator);

	/**
	 * _E[hXi[ǉ܂B
	 * @param listener ǉ_E[hXi[
	 */
	void addDownloadListener(DownloadListener listener);

	/**
	 * _E[hXi[폜܂B
	 * @param listener 폜_E[hXi[
	 */
	void removeDownloadListener(DownloadListener listener);

	/**
	 * IP Messenger̓Ytt@C_E[h܂B<br>
	 * XbhgĂɕA܂B
	 * T^Iɂ̓_E[hqueueɓāA
	 * Ƀ_E[ĥ͈萔ɂ܂B
	 * @param message Message
	 * @param attachment Ytt@C
	 * @param dest ۑ̃fBNg(Kw_E[h, 
	 * Yt̃[gKw܂)܂
	 * t@C(t@C_E[h)B΃pXƍlĂ悢B
	 */
	void saveAttachment(Message message, Attachment attachment, File dest);

	/**
	 * _E[h𒆎~܂B
	 * @param attachment _E[h𒆎~Ytt@C̏
	 */
	void cancelSavingAttachment(Attachment attachment);

	/**
	 * <p>Ytt@Cj邱ƂbZW[ɒʒm܂B</p>
	 * <p>bZW[͕KvɉăT[oɑ΂Ĕjʒm܂B</p>
	 * @param message bZ[W
	 */
	void releaseAttachments(Message message);

	/**
	 * <p>bZ[WoCiɕϊۂ̒Ԃ܂B</p>
	 * <p>̃\bhԂProtocol#maxMessageLengthƔr邱Ƃł܂B</p>
	 * @param message bZ[W
	 * @return 
	 */
	int getMessageLength(String message);

	/**
	 * w肵o[̃Xe[^XbZ[W擾܂B
	 * @param member Ώۂ̃o[
	 */
	void getStatusMessage(UniqueMember member);

	/**
	 * Nݒw肵MessengeroCh
	 * TCP̃AhXƃ|[gԍ擾܂B
	 * oChȂꍇ͗vfȂ̔z񂪕Ԃ܂B
	 * @param conf Nݒ
	 * @return oChAhXƃ|[gԍ̔zB
	 * @throws UnknownHostException 
	 */
	InetSocketAddress[] getTcpBindAddress(LaunchConfiguration conf)
			throws UnknownHostException;

	/**
	 * Nݒw肵MessengeroCh
	 * UDP̃AhXƃ|[gԍ擾܂B
	 * oChȂꍇ͗vfȂ̔z񂪕Ԃ܂B
	 * @param conf Nݒ
	 * @return oChAhXƃ|[gԍ̔zB
	 * @throws UnknownHostException 
	 */
	InetSocketAddress[] getUdpBindAddress(LaunchConfiguration conf)
			throws UnknownHostException;

	// TODO _E[h̎擾
}
