package petaclone.logic;

import jp.takayuki.tools.MessageMap;
import petaclone.AppPreferences;
import petaclone.EventListener;
import petaclone.MessengerFacade;
import petaclone.RuntimeProperties;

/**
 * s݃[hJnCxg̏
 * @author Takayuki Shoji
 */
public class StartAutoAbsence implements EventListener {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * MessengerFacade
	 */
	private MessengerFacade facade;

	/**
	 * RXgN^
	 * @param pref ݒ
	 * @param facade MessengerFacade
	 */
	public StartAutoAbsence(AppPreferences pref, MessengerFacade facade) {
		this.pref = pref;
		this.facade = facade;
	}

	/**
	 * s݃[hJnCxg̏
	 * @param event null
	 */
	public void listen(String eventName, Object event) {
		RuntimeProperties rp = pref.getRuntime();
		if (rp.isAbsence())
			return;

		rp.setAbsenceMessage(mm.get("StartAutoAbsence.message")); //$NON-NLS-1$
		rp.setPresence(RuntimeProperties.PRESENCE_AUTO_ABSENCE);
		facade.sendAbsenceMode(true);
	}

}
