package petaclone.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.widgets.Table;

/**
 * L[̓
 */
public final class ArrowDownBehavior extends KeyAdapter {
	/**
	 * ړ̃e[u
	 */
	private final Table target;

	/**
	 * RXgN^
	 * 
	 * @param target ړ̃e[u
	 */
	public ArrowDownBehavior(Table target) {
		this.target = target;
	}

	public void keyPressed(KeyEvent e) {
		if (e.keyCode == SWT.ARROW_DOWN) {
			if (target.getSelectionCount() <= 0 && target.getItemCount() > 0) {
				target.setSelection(0);
				target.notifyListeners(SWT.Selection, null);
			}
			target.setFocus();
		}
	}
}