package petaclone.swt;

import jp.takayuki.swt.util.SWTUtils;

import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;

/**
 * Rg[̃hbOƃEBhËړA鏈B
 * <p>
 * Shell܂Control̃TuNXɓKpB
 * <p>
 * MouseListenerMouseMoveListenerƂēo^B
 * 
 * @author Takayuki Shoji
 */
public class SWTWindowDragMoveAction extends MouseAdapter implements
		MouseMoveListener {

	/** hbOShell */
	private Shell target;

	/** hbOǂ */
	private boolean drag;

	/** XW */
	private int x;

	/** YW */
	private int y;

	/**
	 * @see org.eclipse.swt.events.MouseAdapter#mouseDown(MouseEvent)
	 */
	public void mouseDown(MouseEvent event) {
		if (event.button != 1) {
			return;
		}
		drag = true;
		x = event.x;
		y = event.y;
		target = SWTUtils.getShellFromWidget(event.widget);
		//System.out.println("MouseDown:" + event.widget);
	}

	/**
	 * @see org.eclipse.swt.events.MouseAdapter#mouseUp(MouseEvent)
	 */
	public void mouseUp(MouseEvent event) {
		drag = false;
		target = null;
		//System.out.println("MouseUp:" + event.widget);
	}

	/**
	 * @see org.eclipse.swt.events.MouseMoveListener#mouseMove(MouseEvent)
	 */
	public void mouseMove(MouseEvent event) {
		if (!drag || target == null) {
			return;
		}
		Shell shell = SWTUtils.getShellFromWidget(event.widget);
		if (target != shell) {
			drag = false;
			target = null;
			return;
		}
		Point location = shell.getLocation();
		shell.setLocation(location.x + event.x - x, location.y + event.y - y);
		//System.out.println("MouseMove:" + event.widget);
	}
}
