package petaclone.swt;

import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.program.Program;

/**
 * vOACR̃LbV
 * @author Takayuki Shoji
 */
public class SharedProgramIcons {
	/** ImagepDisplay */
	private Device device;

	/** 摜̃t@C */
	private static final String[] imageLocations = { //
	//
			"appl.png", //$NON-NLS-1$
			"appl16.png", //$NON-NLS-1$
			"display_new_message.gif", //$NON-NLS-1$
			"feedback.gif", //$NON-NLS-1$
			"help.gif", //$NON-NLS-1$
			"loupe.gif", //$NON-NLS-1$
			"mainwindow.gif", //$NON-NLS-1$
			"message.gif", //$NON-NLS-1$
			"messagebox.gif", //$NON-NLS-1$
			"preference.gif", //$NON-NLS-1$
			"quit.gif", //$NON-NLS-1$
			"reply.gif", //$NON-NLS-1$
			"save.gif", //$NON-NLS-1$
			"send.gif", //$NON-NLS-1$
			"sendto.gif", //$NON-NLS-1$
			"status_absence.png", //$NON-NLS-1$
			"status_absence_file.png", //$NON-NLS-1$
			"status_offline.png", //$NON-NLS-1$
			"status_online.png", //$NON-NLS-1$
			"status_online_file.png", //$NON-NLS-1$
			"folder.gif", //$NON-NLS-1$
			"aborted.gif", //$NON-NLS-1$
			"stickies16.gif", //$NON-NLS-1$
			"white.gif" //$NON-NLS-1$
	};

	/**
	 * ACR<br>
	 * L[: gq܂̓L[[h
	 * l: Image
	 */
	private HashMap icons = new HashMap();

	/**
	 * RXgN^
	 * @param device ImagepDevice
	 */
	public SharedProgramIcons(Device device) {
		this.device = device;
		for (int i = 0; i < imageLocations.length; i++) {
			Image img = TransparentImage.get(device, imageLocations[i]);
			if (img != null)
				icons.put(imageLocations[i], img);
		}
	}

	/**
	 * ׂĂImage܂B
	 * (̌Ăяoȍ~̓CX^X𗘗płȂ)
	 */
	public void release() {
		Iterator itr = icons.values().iterator();
		while (itr.hasNext()) {
			Image img = (Image) itr.next();
			if (!img.isDisposed()) {
				img.dispose();
			}
		}
		icons = null;
	}

	/**
	 * gqɑ΂ACR擾܂B
	 * LbVĂȂꍇ͐܂B
	 * @param extention gq
	 * @return gqɑΉImageIuWFNgBΉȂꍇ͔̃ACRԂ܂B
	 */
	public Image getIcon(String extention) {
		// LbV𒲂ׂ
		if (icons.containsKey(extention)) {
			return (Image) icons.get(extention);
		}
		// LbVĂȂΎ擾
		Program p = Program.findProgram(extention);
		if (p == null) {
			// ̃ACRԂ
			return (Image) icons.get("white.gif"); //$NON-NLS-1$
		}
		ImageData data = p.getImageData();
		if (data == null) {
			// ̃ACRԂ
			return (Image) icons.get("white.gif"); //$NON-NLS-1$
		}
		Image image = new Image(device, data);
		icons.put(extention, image);
		return image;
	}

	/**
	 * tH_̃ACR擾܂B
	 * @return tH_ACR
	 */
	public Image getFolderIcon() {
		return (Image) icons.get("folder.gif"); //$NON-NLS-1$
	}
}
