package petaclone.swt.logic;

import petaclone.AppPreferences;
import petaclone.Events;
import petaclone.MessageLogger;
import petaclone.MessengerFacade;
import petaclone.swt.SWTMainWindow;
import petaclone.swt.SWTMessageWindow;

/**
 * VKbZ[WEBhE̕\vCxg܂B
 * @author Takayuki Shoji
 */
public class SWTOpenBlankMessageWindow extends AbstractSWTEventListener {

	/**
	 * CEBhE
	 */
	private SWTMainWindow main;

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * MessengerFacade
	 */
	private MessengerFacade facade;

	/**
	 * MessageLogger
	 */
	private MessageLogger msgLogger;

	/**
	 * RXgN^
	 * @param display
	 * @param main
	 * @param pref
	 * @param facade
	 * @param msgLogger bZ[WL^
	 */
	public SWTOpenBlankMessageWindow(SWTMainWindow main, AppPreferences pref,
			MessengerFacade facade, MessageLogger msgLogger) {
		this.main = main;
		this.pref = pref;
		this.facade = facade;
		this.msgLogger = msgLogger;
	}

	/**
	 * Cxg܂B
	 */
	protected void handleEvent(String eventName, Object event) {

		boolean independent = Events.OpenBlankIndependentMessageWindow
				.equals(eventName);

		if (!independent && !pref.getUseIndependentMessageWindow()
				&& !main.getVisible()) {
			main.show(true);
		}

		SWTMessageWindow.openNewMessageWindow(main, pref, facade, msgLogger,
				null, false, independent);
	}

}
