package petaclone.swt.logic;

import petaclone.AppPreferences;
import petaclone.MessageLogger;
import petaclone.MessengerFacade;
import petaclone.swt.SWTMainWindow;
import petaclone.swt.SWTMessageWindow;

/**
 * VtⳎZbg\
 * @author Takayuki Shoji
 */
public class SWTOpenNewStickiesSet extends AbstractSWTEventListener {

	/**
	 * CEBhE
	 */
	private SWTMainWindow main;

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * MessengerFacade
	 */
	private MessengerFacade facade;

	/**
	 * MessageLogger
	 */
	private MessageLogger msgLogger;

	/**
	 * RXgN^
	 * @param display
	 * @param main
	 * @param pref
	 * @param facade
	 * @param msgLogger bZ[WL^
	 */
	public SWTOpenNewStickiesSet(SWTMainWindow main, AppPreferences pref,
			MessengerFacade facade, MessageLogger msgLogger) {
		this.main = main;
		this.pref = pref;
		this.facade = facade;
		this.msgLogger = msgLogger;
	}

	protected void handleEvent(String eventName, Object event) {
		if (!pref.getUseIndependentMessageWindow() && !main.getVisible())
			main.show(true);

		SWTMessageWindow.openNewStickiesSet(main, pref, facade, msgLogger);
	}
}
